<template>
  <div>
    <Input label="Email" inputType="email" model="email"/>
    <Input label="Password" inputType="password" model="password"/>
    <Input label="Confirm Password" inputType="password" model="checkPassword"/>
    <Button :action="sendData" text="Submit" buttonType="primaryAlt"/>
  </div>
</template>

<script lang="ts">
import gql from 'graphql-tag';
import Vue from 'vue';

interface RegistrationFormData {
  email: string;
  password: string;
  checkPassword: string;
}

const createUser: any = gql`
  mutation createUser(
    $email: String!
    $password: String!
    $checkPassword: String!
  ) {
    createUser(
      user: {
        email: $email
        password: $password
        checkPassword: $checkPassword
      }
    ) {
      id
    }
  }
`;

export default Vue.extend({
  data(): RegistrationFormData {
    return {
      email: '',
      password: '',
      checkPassword: '',
    };
  },

  methods: {
    async sendData(): Promise<void> {
      const { email, password, checkPassword, $apollo }: any = this;
      if (!email || !password || !checkPassword) {
        alert('Nenhum dos campos deve ficar vazio.');
      } else if (password !== checkPassword) {
        alert('As senhas devem ser iguais');
      } else {
        const response = await $apollo.mutate({
          mutation: createUser,
          variables: {
            email,
            password,
            checkPassword,
          },
        });
      }
    },
  },
});
</script>
